;===============================================================================
; Program using the font library with a font in a FILE
; Using grayscale graphic mode (Gray4)
;
; This program draw a string (on the first plane) and draw a shadow to this
;string (on the second plane)
;
; To use the program don't forget to put the file T5x12.89s on your TI89 !
;===============================================================================

	include "..\..\doorsos.h"
	include "..\..\graphlib.h"
	include "..\..\userlib.h"
	include "..\..\filelib.h"
	include "..\..\fontlib.h"         ;Include the font header to use fonctions

	xdef _main
	xdef _comment
	xdef _ti89

writestr MACRO
	move.w \1,d0                ;We will write on x
	move.w \2,d1                ;We will write on y
	move.l \3,a0                ;Store string address in a0
	jsr fontlib::WriteString    ;Write the string stored at a0
	ENDM

_main:
	jsr graphlib::gray4         ;Put grayscale 4 mode
	move.w #1,graphlib::choosescreen  ; Tell to choose screen with a1
	move.l graphlib::plane1,a1  ;Choose the second plane
	jsr graphlib::clr_scr       ;Clear the second plane
	move.l graphlib::plane0,a1  ;Choose the first plane
	jsr graphlib::clr_scr       ;Clear the first plane

	move.l #Name,a0             ;Name of the file to search
	move.l #0,d1                ;0 -> We take the first file found
	jsr filelib::search         ;Search for the file

	move.l #Name,d1
	cmp.l a0,d1                 ;a0 change ? (<> #name = file found)
	bne FileFound               ;Yes ? Then continue
	rts                         ;Else quit

FileFound:
	lea 12(a0),a0               ;Go to the file handle (a0 is on the name)
	move.w (a0),d0              ;Put the file handle in d0
	DEREF d0,a0                 ;Get the file address in a0
	addq #2,a0                  ;Skip file size (Word, 2 bytes)

	jsr fontlib::InitFont       ;Now initialize the font (at a0)

;For writing string on plane 1 (fontlib::WriteAddr is destination address)

	move.l graphlib::plane1,fontlib::WriteAddr

	writestr #12,#2,#Test
	writestr #12,#22,#Test1
	writestr #12,#42,#Test2
	writestr #12,#62,#Test3

;For writing string on plane 0 (fontlib::WriteAddr is destination address)

	move.l graphlib::plane0,fontlib::WriteAddr

	writestr #10,#0,#Test
	writestr #10,#20,#Test1
	writestr #10,#40,#Test2
	writestr #10,#60,#Test3

	jsr userlib::idle_loop          ;Wait a key from the user

	jsr graphlib::gray2             ;Back to normal mode
	clr.w graphlib::choosescreen    ;LCD_MEM will be used for the graph mem
	rts

Name		dc.b "t5x12",0    ;Font file
Test		dc.b "\ 012 ABC /",0,0  ;String to write on the screen
Test1		dc.b "Terminal Font",0  ;Other string
Test2		dc.b "Font T5x12",0     ;Other string
Test3		dc.b "Shadow example (Grayscale)",0 ;Other String

_comment dc.b "Font example 2 by CandyMan",0

	end
