;===============================================================================
;	Fontlib v1.0 : Font functions by Philippe Gervaise aKa CandyMan
;
;	candyman@i-france.com
;
;	http://www.i-france.com/candyman
;===============================================================================


fontlib::InitFont		EQU	fontlib@0000
;===============================================================================
; InitFont(font)
;
; Initialize the font (font at address FontAddr)
;
;
; Input :
;	a0.l = pointer to the font (start at ID !! With a file skip the 2 bytes of
;		the size !!)
;
; Output: nothing
;	NO REGISTERS DESTROYED
;===============================================================================


fontlib::WriteChar		EQU	fontlib@0001
;===============================================================================
; WriteChar(x, y, char)
;
; Draw a char on the screen
;
;
; Input :
;	d0.w = x
;	d1.w = y
;	d2.w = character to write (0-255)
;
; Output: nothing
;	NO REGISTERS DESTROYED
;===============================================================================


fontlib::WriteString		EQU	fontlib@0002
;===============================================================================
; WriteString(x,y,str)
;
; Draw a string on the screen
;
;
; Input :
;	d0.w = x
;     d1.w = y
;	a0.l = address of the string to write
;
; Output: nothing
;	NO REGISTERS DESTROYED
;===============================================================================


fontlib::WriteAddr		EQU	fontlib@0003
;===============================================================================
; Variable (Long) : Address where to write chars from the font
;===============================================================================


fontlib::FontY			EQU	fontlib@0004
;===============================================================================
; Variable (Byte) : Vertical size of chars (in pixels)
;===============================================================================


fontlib::FontX			EQU	fontlib@0005
;===============================================================================
; Variable (Byte) : Horizontal size of chars (in pixels)
;===============================================================================


fontlib::SpaceX			EQU	fontlib@0006
;===============================================================================
; Variable (Word) : Number of pixels between each chars
;
; Value after fontlib::InitFont : 0
;===============================================================================


fontlib::Italic			EQU	fontlib@0007
;===============================================================================
; Variable (Word) : 0 for normal font
;                   1 for Italic Font
;
; Value after fontlib::InitFont : 0
;===============================================================================

fontlib::Recover			EQU	fontlib@0008
;===============================================================================
; Variable (Word) : 0 for a font with keeped background (chars are sprites)
;                   1 for a font with white background (chars are rectangular)
;
; Value after fontlib::InitFont : 1
;===============================================================================

fontlib::Invert			EQU	fontlib@0009
;===============================================================================
; Variable (Word) : 0 for a normal font (black on white)
;                   1 for an inverted font (white on black)
;
; Value after fontlib::InitFont : 0
;===============================================================================