Uses Crt, Dos, Drivers, UScreen, A320x200, Palette, LittleF;
Type
  FontHeader = Record
    ID : Array[1..4] Of Char;
    Version : Word;
    Flag : Word;
    NCar : Word;
    FirstCar : Word;
    Size : Word;
  End;

  TFontFile = Array[0..65534] Of Byte;
  PTFontFile = ^TFontFile;

Var
  MyEvent : TEvent;
  CurrentChar : Array[1..100, 1..100] Of Byte;
  FontFile : PTFontFile;
  Head : FontHeader;
  FontX, FontY : Word;
  CharN : Byte;
  MemoryState : Pointer;
  FileName : String;

Function GetFile(Name : String) : Boolean;
Var
  F : File;
Begin
  Assign(F, Name);
  {$I-}
  Reset(F, 1);
  If IoResult <> 0 Then Begin GetFile := False; Exit; End;
  {$I+}

  GetMem(FontFile, FileSize(F));
  BlockRead(F, FontFile^, FileSize(F));

  Seek(F, 88);
  BlockRead(F, Head, SizeOf(FontHeader));

  Close(F);
  GetFile := True;
End;

Function WriteFile(Name : String) : Boolean;
Var
  F : File;
  DataSize, CheckSum, I : Word;
Begin
  Assign(F, Name);
  Reset(F, 1);
  DataSize := FileSize(F);
  Close(F);
  ReWrite(F, 1);
  {Recalcule le CheckSum}
  CheckSum := 0;
  For I := 87 To DataSize - 3 Do
    Inc(CheckSum, FontFile^[I - 1]);

  FontFile^[DataSize - 2] := CheckSum And 255;
  FontFile^[DataSize - 1] := CheckSum Shr 8;

  BlockWrite(F, FontFile^, DataSize);
  Close(F);
End;

Function ReadChar(Car : Byte) : Boolean;
Var
  BitMask, Data : Byte;
  I, J, Count : Word;
  DataOfs : Word;

Begin
  FillChar(CurrentChar, SizeOf(CurrentChar), 0);
  FontX := Head.Size Shr 8;
  FontY := Head.Size And 255;

  DataOfs := 88 + SizeOf(FontHeader) + (Car * FontX * FontY) Shr 3;
  BitMask := 1 Shl (7 - ((Car * FontX * FontY) And 7));

  For J := 1 To FontY Do
  Begin
    For I := 1 To FontX Do
    Begin
      If FontFile^[DataOfs] And BitMask <> 0 Then CurrentChar[I, J] := 0 Else
        CurrentChar[I, J] := 1;
      BitMask := BitMask Shr 1;
      If BitMask = 0 Then
      Begin
        BitMask := 128; {10000000}
        Inc(DataOfs);
      End;
    End;
  End;
  ReadChar := True;
End;

Procedure WriteChar(Car : Byte);  {0-255, relatif au code ascii}
Var
  BitMask : Byte;
  DataOfs, I, J : Word;
Begin
  Car := Car - Head.FirstCar Shr 8;
  DataOfs := 88 + SizeOf(FontHeader) + (Car * FontX * FontY) Shr 3;
  BitMask := 1 Shl (7 - ((Car * FontX * FontY) And 7));

  For J := 1 To FontY Do
  Begin
    For I := 1 To FontX Do
    Begin
      If CurrentChar[I, J] = 0 Then FontFile^[DataOfs] := FontFile^[DataOfs] Or BitMask Else
      Begin
        BitMask := Not(BitMask);
        FontFile^[DataOfs] := FontFile^[DataOfs] And BitMask;
        BitMask := Not(BitMask);
      End;

      BitMask := BitMask Shr 1;
      If BitMask = 0 Then
      Begin
        BitMask := 128; {10000000}
        Inc(DataOfs);
      End;
    End;
  End;
End;

Procedure DrawBlock(X, Y, Zoom : Word);
Begin
  BoxD(Zoom * X + 1, Zoom * Y + 1, Zoom * X + Zoom,
    Zoom * Y + Zoom, CurrentChar[X + 1, Y + 1]);
End;

Procedure DrawGrid(Zoom : Word);
Var
  I, J : Word;
Begin
  HideMouse;
  For J := 0 To FontY - 1 Do
    For I := 0 To FontX - 1 Do
      DrawBlock(I, J, Zoom);
  BoxEmpty(0, 0, Zoom * FontX, Zoom * FontY, 27, 22);
  ShowMouse;
End;

Procedure WriteLittleChar;
Var
  I, J : Word;
Begin
  For J := 1 To FontY Do
    For I := 1 To FontX Do
      If CurrentChar[I, J] <> 0 Then
        Mem[$A000 : 161 + I + (22 + J) * 320] := 4 Else
        Mem[$A000 : 161 + I + (22 + J) * 320] := 14;
End;

Procedure WriteNumByte(X, Y : Word; Num : Byte);
Var
  TmpStr : String;
Begin
  Str(Num, TmpStr);
  If Num < 99 Then TmpStr := ' ' + TmpStr;
  If Num < 9 Then TmpStr := ' ' + TmpStr;
  TransSentence(TmpStr, 14, 4, X, Y, 666, 666, 666);
End;

Procedure WriteAround;
Begin
  TransSentence('DOS CHAR   :', 15, 0, 160, 1, 666, 666, 666);
  PrintChar(Chr(CharN), 213, 0, 14, 4);
  TransSentence('INDEX      : ', 15, 0, 160, 8, 666, 666, 666);
  WriteNumByte(212, 8, CharN);
  TransSentence('NEW CHAR   :', 15, 0, 160, 14, 666, 666, 666);
  WriteLittleChar;
  BoxEmpty(161, 22, 161 + FontX, 22 + FontY, 27, 22);

  TransSentence('FIRST CHAR : ', 15, 0, 160, 25 + FontY, 666, 666, 666);
  WriteNumByte(212, 25 + FontY, Head.FirstCar Shr 8);
  TransSentence('LAST CHAR  : ', 15, 0, 160, 31 + FontY, 666, 666, 666);
  WriteNumByte(212, 31 + FontY, Head.FirstCar Shr 8 + Head.NCar Shr 8 - 1);

  TransSentence('F2 = SAVE WHOLE FONT', 15, 0, 0, 162, 666, 666, 666);
  TransSentence('F3 = RESTORE LAST SAVED FONT', 15, 0, 0, 168, 666, 666, 666);

(*  TransSentence('F4 = SAVE CURRENT CHAR', 15, 0, 120, 162, 666, 666, 666);
  TransSentence('F5 = RESTORE CURRENT CHAR', 15, 0, 120, 168, 666, 666, 666);*)


  TransSentence('+ = NEXT CHAR', 15, 0, 0, 180, 666, 666, 666);
  TransSentence('- = PREVIOUS CHAR', 15, 0, 0, 186, 666, 666, 666);
End;

Var
  Rep : Char;
  BlockX, BlockY : Word;
  Zoom : Word;

Begin
  Car := Car2;
  FileName := OpenFile('*.89s');
  If FileName = '' Then
  Begin
    ClrScr;
    WriteLn('Font Editor v1.0 by Philippe Gervaise aKa CandyMan');
    Halt;
  End;

  Asm
    Mov AX,13h
    Int 10h
  End;

  Mark(MemoryState);

  ReadFont('FontEdit.Fnt');
  InitCar;

  GetFile(FileName);
  ReadChar(0);
  CharN := Head.FirstCar Shr 8;
  Pal(1, 63, 63, 63);
  Pal(0, 0, 0, 0);
  ClsD(0);
  InitEvents;
  Zoom := 160 Div (FontY + 1);
  If FontX * Zoom > 160 Then
  Zoom := 160 Div (FontX + 1);
  DrawGrid(Zoom);
  WriteAround;
  Repeat
    GetMouseEvent(MyEvent);
    If MyEvent.Buttons <> 0 Then
    Begin
      If Zone(1, 1, Zoom * FontX + 2, Zoom * FontY + 2) Then
      Begin
        BlockX := ((GetXMouse Div 2) - 1) Div Zoom;
        BlockY := (GetYMouse - 1) Div Zoom;

        CurrentChar[BlockX + 1, BlockY + 1] := MyEvent.Buttons - 1;
        WriteChar(CharN);
        HideMouse;
        DrawBlock(BlockX, BlockY, Zoom);
        WriteLittleChar;
        ShowMouse;
      End;
    End;
    If KeyPressed Then
    Begin
      Rep := ReadKey;
      If UpCase(Rep) = 'S' Then
      Begin
      End;

      If Rep = '+' Then
        If CharN < Head.FirstCar Shr 8 + Head.NCar Shr 8 - 1 Then
        Begin
          Inc(CharN);
          ReadChar(CharN - Head.FirstCar Shr 8);
          DrawGrid(Zoom);
          WriteAround;
        End;

      If Rep = '-' Then
        If CharN > Head.FirstCar Shr 8 Then
        Begin
          Dec(CharN);
          ReadChar(CharN - Head.FirstCar Shr 8);
          DrawGrid(Zoom);
          WriteAround;
        End;

      If Rep = Chr(0) Then
      Begin
        Rep := ReadKey;
        If Rep = Chr(60) Then   {F2 = Sauve toute la fonte}
        Begin
          WriteChar(CharN);
          WriteFile(FileName);
        End;
        If Rep = Chr(61) Then   {F3 = Restore toute la fonte}
        Begin
          GetFile(FileName);
          ReadChar(CharN - Head.FirstCar Shr 8);
          HideMouse;
          WriteLittleChar;
          DrawGrid(Zoom);
          ShowMouse;
        End;
(*        If Rep = Chr(62) Then   {F4 = Sauve le caractere courant}
          WriteChar(CharN);*)
(*        If Rep = Chr(63) Then   {F5 = Restore le caractere courant}
        Begin
          ReadChar(CharN - Head.FirstCar Shr 8);
          HideMouse;
          WriteLittleChar;
          DrawGrid(Zoom);
          ShowMouse;
        End;*)

      End;
    End;
  Until Rep = Chr(27);

  DoneEvents;
  TextMode(3);
  Dispose(MemoryState);
End.