{$M 8192, 0, 100000}
Uses Crt, Dos, UScreen;
Label ExitStatus, CompileStatus;
Type
  FontHeader = Record
    ID : Array[1..4] Of Char;
    Version : Word;
    Flag : Word;
    NCar : Word;
    FirstCar : Word;
    Size : Word;
  End;

  BmpHeader = Record
    ID : Array[1..2] Of Char; {'BM'}
    Length : LongInt; {Taille du fichier}
    Reserved1 : Word;
    Reserved2 : Word;
    BitOffset : LongInt; {54 + palette ?}

    Size : LongInt; {40}
    X, Y : LongInt;
    NPlanes : Word;
    BitCount : Word;
    Compression : LongInt; {0}
    SizeImage : LongInt;
    XPM, YPM : LongInt;
    ClrUsed : LongInt; {0}
    ClrImportant : LongInt; {0}
  End;

Var
  F, G : File;
  H : Text;
  Bmp : BmpHeader;
  Fnt : FontHeader;
  X, Y, FontX, FontY, I, CurrentCar : Word;
  RealBmpX, ExtraX : Word;
  Data : Byte;
  DataRGB : Array[1..3] Of Byte;
  MemX, MemY : Word;

  CurrentByte : Byte;
  CurrentBit : Byte;
  Error : Word;
  Line, Name, TmpStr : String;
  ErrorVal : Integer;
  AsmFile : Boolean;
  ByteCount : Word;
  FontType : Word;

Procedure Pal(ColorNo : Byte; R,G,B : Byte);
Begin
 Port[$3c8] := ColorNo;
 Port[$3c9] := R;
 Port[$3c9] := G;
 Port[$3c9] := B;
End;

Function IntToStr(Num : Word) : String;
Var
  TmpStr : String;
Begin
  Str(Num, TmpStr);
  If Num <= 99 Then TmpStr := TmpStr + ' ';
  If Num <= 9 Then TmpStr := TmpStr + ' ';
  IntToStr := TmpStr;
End;

Procedure HaltProg;
Begin
  ClrScr;
  WriteLn('Font Maker v1.0 By Philippe Gervaise aKa CandyMan');
  Halt;
End;

Begin
  Car := Car2;

  ChoiceTitle := 'Choose font type :';
  AddChoice('Make font from bitmap (.BMP)');
  AddChoice('Make empty font');

  FontType := Choice;
  DoneChoice;

  If FontType = 0 Then HaltProg;

  Cls(176, 1, 7);

  If FontType = 1 Then
  Begin
    Name := OpenFile('*.bmp');
    If Name = '' Then HaltProg;
  End Else
    Name := Ask('Filename (max 8 chars, no extension) : ', Digit + Alpha + NoSpace);

  Cls(176, 1, 7);
  Line := Ask('Characters size (horizontal, in pixels) :', Digit);
  Val(Line, FontX, ErrorVal);

  If FontType = 2 Then
  Begin
    Cls(176, 1, 7);
    Line := Ask('Characters size (Vertical, in pixels) :', Digit);
    Val(Line, FontY, ErrorVal);

    Cls(176, 1, 7);
    Line := Ask('First Char code : ', Digit);
    Val(Line, Fnt.FirstCar, ErrorVal);

    Cls(176, 1, 7);
    Line := Ask('Last Char code : ', Digit);
    Val(Line, Fnt.NCar, ErrorVal);


    {Ecrit l'header de la fonte}
    Fnt.ID := '_Fnt';
    Fnt.Version := 256; {Pour le 68000, -> 1}
    Fnt.Flag := 0;  {Rien pour l'instant}
    Fnt.NCar := Swap(Fnt.NCar - Fnt.FirstCar + 1);
    Fnt.FirstCar := Swap(Fnt.FirstCar);
    Fnt.Size := FontX * 256 + FontY;

    Assign(G, Name + '.fnt');
    ReWrite(G, 1);
    BlockWrite(G, Fnt, SizeOf(FontHeader));
    Data := 0;
    ByteCount := ((Fnt.NCar Shr 8) * FontX * FontY);
    If ByteCount Mod 8 = 0 Then ByteCount := ByteCount Shr 3 Else
      ByteCount := ByteCount Shr 3 + 1;

    For I := 1 To ByteCount Do
      BlockWrite(G, Data, 1);

    Data := 0;
    BlockWrite(G, Data, 1);
    Data := 45;
    BlockWrite(G, Data, 1);

    Close(G);

    Goto CompileStatus;
  End;

  Cls(176, 1, 7);
  Line := Ask('First Char code : ', Digit);
  Val(Line, Fnt.FirstCar, ErrorVal);

  Cls(176, 1, 7);
  ChoiceTitle := 'Choose output format';
  AddChoice('Font file (.89s)');
  AddChoice('Asm file (.asm)');
  If Choice = 2 Then AsmFile := True Else AsmFile := False;
  DoneChoice;

  Asm
    Mov AX, 13h
    Int 10h
  End;

  Name := Copy(Name, 1, Pos('.', Name) - 1); {Elimine l'extension}
  Assign(F, Name + '.bmp');

  If AsmFile = False Then
  Begin
    Assign(G, Name + '.fnt');
    ReWrite(G, 1);
  End Else
  Begin
    Assign(H, Name + '.asm');
    ReWrite(H);
  End;

  Reset(F, 1);
  BlockRead(F, Bmp, SizeOf(BmpHeader));

  FontY := Bmp.Y;  {Taille Y de la fonte}
  ExtraX := 0; {Nombre de pixels entre chaque caractere}

  RealBmpX := Bmp.SizeImage Div Bmp.Y;

  CurrentByte := 0; {Octet courant pour les donnes}
  CurrentBit := 7; {Bit courant dans l'octet CurrentByte}

  {Ecrit l'header de la fonte}
  Fnt.ID := '_Fnt';
  Fnt.Version := 256; {Pour le 68000, -> 1}
  Fnt.Flag := 0;  {Rien pour l'instant}
  Fnt.FirstCar := Swap(Fnt.FirstCar);
  Fnt.NCar := (Bmp.X Div (FontX + ExtraX) + 1) * 256;
  If Bmp.X Mod (FontX + ExtraX) = 0 Then Dec(Fnt.NCar, 256);
  Fnt.Size := FontX * 256 + FontY;

  If AsmFile = False Then BlockWrite(G, Fnt, SizeOf(FontHeader)) Else
  Begin
    WriteLn(H, 'font:');
    WriteLn(H, ' dc.l "_Fnt"    ;Identification');
    WriteLn(H, ' dc.w 1         ;Version (1)');
    WriteLn(H, ' dc.w 0         ;Misc word');
    WriteLn(H, ' dc.w ' + IntToStr(Fnt.NCar Div 256) + '       ;Number of chars');
    WriteLn(H, ' dc.w ' + IntToStr(Fnt.FirstCar Div 256) + '       ;First char code');
    WriteLn(H, ' dc.b ' + IntToStr(FontY) + '       ;Horizontal size of the chars');
    WriteLn(H, ' dc.b ' + IntToStr(FontX) + '       ;Vertical size of the chars');
    Write(H, ' dc.b %');
  End;

  MemX := 0;
  MemY := 0;
  ByteCount := 0;

  For CurrentCar := 0 To Fnt.NCar Div 256 - 1 Do
  Begin
    If MemX + FontX + ExtraX > 319 Then
      Begin
        MemX := 0;
        Inc(MemY, (FontY + 1));
      End;

    For Y := 0 To FontY - 1 Do
    Begin
      Seek(F, SizeOf(BmpHeader) + 3 * CurrentCar * (FontX + ExtraX)
        + RealBmpX * (FontY - 1 - Y));
      For X := 0 To FontX - 1 Do
      Begin
        BlockRead(F, DataRGB, 3, Error);
        If Error <> 3 Then Goto ExitStatus;
        If DataRGB[1] + DataRGB[2] + DataRGB[3] < 384 Then
        Begin
          Mem[$A000 : MemX + X + (Y + MemY) * 320] := 15;
          CurrentByte := CurrentByte + 1 Shl CurrentBit;
        End;

        If CurrentBit = 0 Then
        Begin
          If AsmFile = False Then BlockWrite(G, CurrentByte, 1) Else
          Begin
            For I := 7 DownTo 0 Do
              If CurrentByte And (1 Shl I) <> 0 Then Write(H, '1') Else
                Write(H, '0');

            If ((Y = FontY - 1) And (CurrentCar = Fnt.NCar Div 256 - 1)) = False Then
            Begin
              WriteLn(H, '');
              Write(H, ' dc.b %');
            End;

            Inc(ByteCount);
          End;
          CurrentBit := 7;
          CurrentByte := 0;
        End Else Dec(CurrentBit);
      End;
    End;

    Inc(MemX, FontX + ExtraX);
  End;

  If AsmFile = True Then WriteLn(H, '');

  If (ByteCount And 1) <> 0 Then
    WriteLn(H, ' dc.b %00000000 ;Alignment byte');

  ExitStatus:

  Close(F);
  If AsmFile = False Then
  Begin
    If CurrentBit <> 7 Then BlockWrite(G, CurrentByte, 1);
    Data := 0;
    BlockWrite(G, Data, 1);
    Data := 45;
    BlockWrite(G, Data, 1);
    Close(G);
  End
  Else Close(H);
  ReadLn;
  TextMode(3);

  CompileStatus:
  If AsmFile = False Then
  Begin
    SwapVectors;
    Exec(GetEnv('COMSPEC'), '/C MakeData ' + Name + '.fnt ' + Name + '.89s main');
    SwapVectors;
{    Erase(G);}
  End;
End.